#!/usr/bin/env/python
# -*- coding:utf-8 -*-

import re


def get_exam_type(row_list):
    """
    对试卷的开头，提取 年份/考试类型
    考试类型：期中/期末/单元测试/月考/联考/随堂练.....
    :return:
    """
    exam_time = ""
    exam_type = ""
    source = ""
    paper_head_list = [i for i in row_list[:30] if i.strip()]
    paper_head_str = "\n"+"\n".join(paper_head_list)
    p0 = re.search("[一二三四五六七八九十\d]\s*[、.．､]|注意事项", paper_head_str)
    if p0:
        paper_head_str = paper_head_str[:p0.start()]
    p1 = re.search("([\d一二三四五六七八九十零]{2,4}年.{1,2}月.{1,2}日|时间\s*[:：][^分]+?((?=上午)|(?=\n)))", paper_head_str)
    p11 = re.search("([\d\-~—]{4,11}学年).*?(.{1,2}月(.{1,2}日)?|第[一二12]学期)|([\d\-~—]{4,11}学年)", paper_head_str)
    p2 = re.search("([期年][中末终](联考)?|模拟|单元测试|随堂练|开学考|[中高联月]考|阶段性考试)", paper_head_str)  # '学年末'
    if p1:
        exam_time = p1.group(0).replace('【', '').replace('】','')
        exam_time = re.sub('时间\s*[:：]', "", exam_time)
    elif p11:
        exam_time = p11.group(1) + p11.group(2) if p11.group(2) else  p11.group(4)
    if p2:
        exam_type = p2.group(0)
        if exam_type == '联考':
            p21 = re.search("([期年][中末终]|模拟|单元测试|随堂练|开学考|[中高月]考|阶段性考试)", paper_head_str)
            if p21:
                exam_type += '、'+p21.group(0)
    p3 = re.search("([^年度期末:：]{2,4}省|[^年度期末（(:：]{2,4}市|学校\s*[:：].*?(?=[,，\s])|\n\s*.+?[一二三四五六八]中)", paper_head_str)
    # sch = re.findall("")
    if p3:
        source = re.sub("学校|[:：\s]",'', p3.group(0))
    d_from = {"type": "s",
              "related_exampaper": [{"file_name": "",
                                    "sch_name": "",
                                   }],
                     },  # 数据来源    s:structured(结构化)、c-1:(crawl-好分数)
    return {'exam_time':exam_time, 'category':exam_type, 'from':d_from}