#!/usr/bin/env/python
# -*- coding:utf-8 -*-

# \n\s{4}(?=[\u4e00-\u9fa5]):\n    "
# (?<=[\u4e00-\u9fa5]) =    vvv     ":


class Label():
    def __init__(self):

        # ;题型
        self.topic_type_id = {
            "单选题": 1,
            "多选题": 2,
            "填空题": 3,
            "实验题": 4,
            "作图题": 6,
            "解答题": 7,
        }

        # ;年份
        self.year_id = {
            "更早": 250,
            "2019": 251,
            "2020": 252,
            "2021": 763,
        }

        # ;教学进度
        # ;同步练习 = 782 ;高考复习 = 785
        self.teach_jindu_id = {
            "同步教学": 782,
            "章节复习": 783,
            "模块复习": 784,
            "高三复习": 785,
        }

        # ;考试类型
        # ;月考试卷 期中试卷 期末试卷 单元测试 高考模拟  同步练习 高考复习 高考真卷  ===》好分数
        # ;周考 单元考 月考 期中考 期末考 联考 模考 自主招生 竞赛  ===》知心慧学
        # ;大数据资源库：(周考/单元考/月考/期中考/期末考/摸底考/收心考/联考/模拟考/自主招生/竞赛/同步练习题/高考复习题/高考真题)
        self.exam_category_id = {
            "周考": 84,
            "单元考": 85,
            "月考": 86,
            "期中考": 88,
            "期末考": 89,
            "联考": 91,
            "模考": 92,
            "自主招生": 243,
            "竞赛": 245,
        }

        # ;中考复习、中考模拟
        self.exam_category_hfs2zyk = {
            "月考试卷": "月考",
            "期中试卷": "期中考",
            "期末试卷": "期末考",
            "单元测试": "单元考",
            "高考模拟": "模考",
            "高考复习": "高考复习题",
            "同步练习": "同步练习题",
            "高考真卷": "高考真题",
        }

        self.exam_category_hfs2zxhx = {
            "月考试卷": "月考",
            "期中试卷": "期中考",
            "期末试卷": "期末考",
            "单元测试": "单元考",
            "高考模拟": "模考",
        }

        # ;题型类别
        # ;高考真卷 = 771
        self.item_type_label_id = {
            "常考题": 70,
            "易错题": 71,
            "好题": 72,
            "压轴题": 73,
            "创新题": 74,
            "概念题": 75,
            "多解题": 77,
            "综合题": 78,
            "自主招生题": 128,
            "高考真题": 771,
            "联考题": 772,
            "模考题": 773,
            "百所名校题": 774,
        }

        # ; 好分数与知心慧学 类型标签的对应
        self.type_label_vs = {
            "is_new_gaokao": "创新题",
            "is_classic": "好题",
            "is_mom": "常考题",
            "is_famous": "百所名校题",
        }

        # ;题型方法
        self.methods_id = {
            "综合法": 109,
            "图像法": 111,
            "图解法": 602,
            "整体法与隔离法": 114,
            "等效法": 118,
            "类比法": 119,
            "补偿法": 120,
            "对称法": 123,
            "逆向思维法": 124,
            "极限法": 222,
            "假设法": 223,
            "矢量法": 232,
            "微元法": 234,
            "转换法": 601,
            "估算法": 603,
        }

        self.id2kps_phy = {
            1323: '曲线运动的条件',
            1328: '小船渡河问题',
            1358: '磁感应强度',
            1359: '匀强磁场',
            1360: '磁通量',
            1366: '产生感应电流的条件',
            1367: '电磁感应现象的应用',
            1375: '电磁场',
            1376: '电磁波',
            1378: '电磁波谱',
            1379: '电磁波生活中的应用',
            1383: '热辐射',
            1384: '黑体辐射',
            1385: '能量子',
            1386: '能级',
            1455: '磁现象',
            1456: '电流的磁效应',
            1457: '磁场',
            1458: '地磁场',
            1459: '磁感线',
            1460: '安培定则',
            2851: '电荷、三种起电方式',
            2853: '静电力做功',
            2854: '电势能',
            2855: '电源',
            2856: '电流表达式',
            2859: '电功和电功率',
            2860: '焦耳定律',
            2861: '电动势',
            2862: '闭合电路的欧姆定律',
            2864: '闭合电路的动态分析',
            2867: '全反射',
            2869: '光导纤维及其运用',
            2870: '光的干涉',
            2871: '光的双缝干涉和薄膜干涉',
            2874: '实验：用双缝干涉测量光的波长',
            2881: '光的衍射',
            2928: '物质由大量分子组成',
            2929: '扩散现象',
            2930: '布朗运动',
            2931: '分子间的作用力',
            2932: '实验：用油膜法估测分子的大小',
            2935: '随机性和统计规律',
            2938: '状态参量与平衡态',
            2939: '热平衡与温度',
            2941: '焦耳实验',
            2942: '功与内能的改变',
            2956: '黑体与黑体辐射',
            2957: '光电效应',
            2958: '爱因斯坦光电效应方程',
            2959: '康普顿效应与光子的动量',
            2960: '电子',
            2962: '原子的核式结构模型',
            2964: '天然放射现象',
            2965: '射线的本质',
            2966: '原子核的组成',
            3089: '电路中的能量转化',
            3104: '质点',
            3105: '参考系与坐标系',
            3106: '时刻和时间',
            3107: '路程和位移',
            3108: '矢量和标量',
            3110: '速度与速率',
            3111: '平均速度和瞬时速度',
            3112: 'x-t图象',
            3114: '加速度',
            3115: 'v-t图象',
            3116: '光电门传感器的使用',
            3117: '打点计时器使用',
            3118: '速度与时间的关系',
            3119: '位移-时间的关系',
            3120: '速度与位移的关系',
            3122: '自由落体运动',
            3123: '伽利略研究自由落体的实验',
            3125: '运动图象',
            3126: '匀变速直线运动规律和推论',
            3127: '竖直上抛和类竖直上抛运动',
            3128: '追及相遇问题',
            3129: '实验：研究匀变速直线运动及改编实验',
            3130: '力和力的性质',
            3131: '重力',
            3132: '弹力',
            3133: '胡克定律',
            3134: '实验：探究弹簧弹力与弹簧形变量的关系',
            3135: '滑动摩擦力',
            3136: '静摩擦力',
            3137: '作用力与平衡力',
            3138: '牛顿第三定律',
            3140: '力的合成',
            3141: '力的分解',
            3142: '平行四边形定则',
            3143: '实验：验证力的平行四边形定则',
            3145: '三力平衡',
            3148: '伽利略理想实验',
            3149: '牛顿第一定律',
            3151: '牛顿第二定律',
            3152: '实验：探究加速度与力、质量的关系',
            3153: '实验：牛顿第二定律创新型实验',
            3155: '力学单位制',
            3156: '量纲法',
            3158: '瞬时问题',
            3160: '连接体问题',
            3161: '弹簧动力学问题',
            3163: '动力学临界问题',
            3164: '超重与失重',
            3165: '动力学图像问题',
            3166: '两类动力学',
            3167: '传送带综合问题',
            3168: '板块综合问题',
            3169: '曲线运动的特点',
            3170: '相关联问题',
            3172: '研究平抛运动',
            3174: '平抛运动',
            3181: '描述圆周运动的物理量',
            3182: '匀速圆周运动',
            3183: '变速圆周运动',
            3185: '向心力',
            3186: '实验：探究向心力大小的表达式',
            3188: '向心加速度',
            3191: '水平类圆周运动',
            3192: '竖直类圆周运动',
            3193: '离心、近心现象',
            3195: '圆周运动临界问题',
            3196: '绳杆模型',
            3201: '开普勒三大定律',
            3205: '万有引力定律',
            3206: '引力常量的测定',
            3208: '测中心天体质量',
            3209: '测中心天体密度',
            3211: '三种宇宙速度',
            3212: '卫星运行的规律(追击)',
            3213: '近地卫星、同步卫星',
            3214: '变轨与能量',
            3216: '经典时空观和相对论时空观',
            3217: '牛顿力学的局限性',
            3223: '万有引力的两大推论',
            3224: '双星、多星问题',
            3228: '功',
            3229: '功率',
            3230: '机车启动',
            3231: '重力做功',
            3232: '重力势能',
            3233: '重力做功与重力势能的变化关系',
            3234: '弹性势能',
            3235: '实验：探究弹簧弹性势能表达式',
            3239: '动能、动能变化量',
            3240: '动能定理',
            3242: '动能与势能的相互转化',
            3243: '机械能守恒的条件、机械能守恒定律',
            3244: '机械能守恒定律的应用',
            3245: '实验：验证机械能守恒定律',
            3246: '一对相互作用力做功的特点',
            3247: '变力做功',
            3248: '动能定理的应用',
            3249: '功能关系的应用',
            3250: '实验：力学综合性实验',
            3251: '电荷守恒定律',
            3252: '元电荷、比荷',
            3254: '静电力常量',
            3255: '库仑定律静力学问题',
            3256: '库仑定律动力学问题',
            3258: '电场',
            3259: '电场强度与电场力',
            3260: '点电荷的电场、匀强电场',
            3261: '电场线',
            3262: '电场强度的叠加',
            3264: '静电平衡',
            3265: '静电屏蔽',
            3269: '电势',
            3270: '电势差',
            3271: '等势面',
            3273: '电势差与电场强度的关系',
            3275: '电容器',
            3277: '电容',
            3279: '带电粒子在电场中的运动',
            3280: '示波管',
            3282: '电场线、等势面粒子运动轨迹的关系',
            3283: '利用等势面确定电场',
            3284: '带电粒子在电场和重力场组成的复合场中的运动',
            3286: '带电粒子在交变电场中的运动',
            3287: '电场中的图像问题',
            3290: '导体的电阻',
            3291: '影响导体电阻的因素',
            3292: '实验：描绘小灯泡伏安特性曲线',
            3293: '游标卡尺与螺旋测微器',
            3294: '测定金属的电阻率',
            3296: '串并联电路',
            3297: '电压表和电流表构造与改装',
            3298: '内接法与外接法',
            3299: '滑动变阻器限流接法与分压接法',
            3301: '欧姆表原理及使用',
            3302: '多用电表的原理及使用',
            3303: '探索黑箱内电阻',
            3304: '用多用表判断电路故障',
            3306: '实验：半偏法测电表内阻',
            3307: '实验：测电阻创新型实验',
            3308: '闭合电路能量分析',
            3309: '含电容器的闭合电路',
            3310: '实验：测定电池的电动势和内阻',
            3312: '能量与可持续发展',
            3313: '能量守恒定律',
            3315: '两种U-I图像',
            3316: '实验：测电源电动势和内阻创新型实验',
            3317: '几种常见的磁场',
            3318: '安培分子电流假说',
            3321: '寻求碰撞中的不变量',
            3322: '动量变化量',  # 动量、动量变化量
            3323: '动量',
            3325: '冲量',
            3326: '动量定理',
            3327: '动量定理的应用',
            3329: '动量守恒定律',
            3331: '实验：验证动量守恒定律',
            3333: '弹性碰撞',
            3334: '非弹性碰撞',
            3336: '反冲运动',
            3338: '动量和能量综合问题',
            3342: '弹簧振子',
            3343: '振动图象',
            3344: '振幅、周期、频率、相位',
            3346: '简谐运动的表达式',
            3349: '简谐运动的回复力',
            3350: '简谐运动的能量',
            3352: '单摆',
            3354: '单摆的周期',
            3355: '实验：探究单摆的运动、用单摆测定重力加速度',
            3357: '能量、阻尼振动',
            3358: '简谐运动的综合问题',
            3359: '受迫振动',
            3360: '共振',
            3363: '波的形成和传播',
            3364: '横波和纵波',
            3365: '机械波',
            3367: '波的图象',
            3368: '波长、频率和波速',
            3370: '波的反射',
            3371: '波的折射',
            3372: '波的衍射',
            3374: '波的叠加',
            3375: '波的干涉',
            3377: '多普勒效应',
            3379: '机械振动和机械波',
            3380: '波的图象与振动图象',
            3381: '折射率',
            3382: '实验：测定玻璃的折射率',
            3384: '偏振、偏振现象及其运用',
            3388: '安培力',
            3389: '左手定则',
            3390: '磁电式电流表',
            3392: '洛伦兹力的方向和大小',
            3393: '电视显像管的工作原理',
            3395: '带电粒子在匀强磁场中的运动',
            3397: '质谱仪和回旋加速器',
            3399: '带电粒子在组合场中的运动',
            3400: '带电粒子在复合场中的运动',
            3403: '楞次定律',
            3404: '右手定则',
            3407: '感应电动势的产生条件',
            3408: '法拉第电磁感应定律',
            3409: '导线切割磁感线时的感应电动势',
            3412: '电磁感应现象中的感生电场',
            3413: '涡流',
            3414: '电磁阻尼和电磁驱动',
            3416: '互感现象',
            3417: '自感现象',
            3418: '自感系数',
            3419: '磁场能量',
            3421: '电磁感应的综合问题',
            3425: '交变电流',
            3426: '交变电流的产生',
            3428: '交流电的四个值',
            3429: '正弦式交变电流的公式和图像',
            3430: '电感器对交变电流的阻碍作用',
            3431: '电容器对交变电流的阻碍作用',
            3434: '理想变压器',
            3435: '远距离输电',
            3436: '原副线圈电流、电压、功率的关系',
            3438: '交变电流与电磁感应的综合',
            3439: '理想变压器动态变化',
            3442: '电磁振荡的产生',
            3443: '电磁振荡中的过程分析',
            3444: '电磁波',
            3445: '麦克斯韦电磁场理论',
            3447: '无线电波的发射和接收',
            3449: '电磁波谱',
            3451: '传感器及种类',
            3456: '传感器的应用',
            3457: '利用传感器制作简单的自动控制装置',
            3458: '分子动理论',
            3459: '分子运动速率分布图像',
            3460: '气体压强的微观意义',
            3462: '分子动能',
            3463: '分子势能',
            3464: '物体的内能',
            3466: '温度计与温标',
            3467: '玻意耳定律',
            3469: '气体的等压变化',
            3473: '晶体和非晶体',
            3474: '晶体的微观结构',
            3475: '气体的等容变化',
            3476: '理想气体',
            3477: '理想气体状态方程',
            3478: '对气体实验定律的微观解释',
            3481: '气体实验定律综合应用',
            3482: '液体的微观结构',
            3483: '液体的表面张力',
            3484: '浸润和不浸润',
            3485: '毛细现象',
            3486: '液晶',
            3487: '饱和汽、饱和汽压',
            3488: '热与内能的改变',
            3489: '热力学第一定律',
            3493: '能量守恒定律（热学）',
            3495: '热力学第二定律',
            3496: '热力学定律与气体定律的综合',
            3497: '黑体辐射的实验规律',
            3498: '能量量子化',
            3499: '光的波粒二象性',
            3500: 'α粒子散射实验',
            3501: '光谱与氢原子光谱',
            3502: '氢原子光谱的实验规律',
            3503: '氢原子的能级公式和跃迁',
            3504: '玻尔理论对氢光谱的解释',
            3505: '玻尔理论的局限性',
            3507: '物质波',
            3508: '量子力学的应用',
            3510: '原子核的衰变',
            3511: '半衰期',
            3512: '核反应',
            3513: '放射性同位素及其应用',
            3514: '人工转变',
            3515: '质子和中子的发现',
            3516: '衰变反冲轨迹',
            3517: '辐射与安全',
            3520: '核力与四种基本相互作用',
            3523: '新粒子及分类',
            3524: '核裂变、裂变反应堆',
            3525: '核聚变',
            3526: '结合能',
            3527: '质量亏损',
            3528: '爱因斯坦质能方程',
            3533: '静力学的受力分析',
            3534: '静力学临界问题',
            3535: '多力平衡',
            3536: '整体法与隔离法',
            3537: '动态平衡',
            3538: '类平抛运动',
            3539: '斜抛运动',
            3540: '电场中的功能关系',
            3541: '激光的特点及其运用',
            3543: '实验：探究做功与物体动能变化的关系',
            3841: '一对滑动摩擦力做功',
            3861: '实验：探究小车速度随时间变化的规律',
            3864: '运动的合成与分解',
            3865: '行星运动的两种学说',
            10214: '光的颜色及色散定义',
            10219: '色散的几种情况',
            10782: '电磁波的传输、应用',
            12813: '物理学史',
            12815: '研究物理学方法',
            12816: '库伦定律的内容以及计算',
            12817: '电场与力学综合',
            12818: '带电粒子在有界磁场中的运动',
            12819: '带电粒子在磁场中运动的临界问题',
            12820: '带电粒子在磁场中运动的两个基本公式',
            12821: '带电粒子在磁场中的多解问题',
            12822: '速度选择器、磁流体发动机',
            12823: '电磁感应电路问题',
            12824: '电磁感应动力学问题',
            12825: '电磁感应能量以及动量问题',
            12826: '电磁感应图象问题',
            12827: '电磁感应单棒模型',
            12828: '电磁感应双棒模型',
            12829: '充气、抽气',  # 充气、灌气类问题
            12830: '灌气类问题',  # 抽气类问题
            12831: '图象问题',
            12832: '水银柱类综合问题',
            12833: '活塞类综合问题'}

        # 201511100192916

        self.sps_first_id = {
            1323: '曲线运动的条件',
            1328: '小船渡河问题',
            1358: '磁感应强度',
            1359: '匀强磁场',
            1360: '磁通量',
            1366: '产生感应电流的条件',
            1367: '电磁感应现象的应用',
            1375: '电磁场',
            1376: '电磁波',
            1378: '电磁波谱',
            1379: '电磁波生活中的应用',
            1383: '热辐射',
            1384: '黑体辐射',
            1385: '能量子',
            1386: '能级',
            1455: '磁现象',
            1456: '电流的磁效应',
            1457: '磁场',
            1458: '地磁场',
            1459: '磁感线',
            1460: '安培定则',
            2851: '电荷、三种起电方式',
            2853: '静电力做功',
            2854: '电势能',
            2855: '电源',
            2856: '电流表达式',
            2859: '电功和电功率',
            2860: '焦耳定律',
            2861: '电动势',
            2862: '闭合电路的欧姆定律',
            2864: '闭合电路的动态分析',
            2867: '全反射',
            2869: '光导纤维及其运用',
            2870: '光的干涉',
            2871: '光的双缝干涉和薄膜干涉',
            2874: '实验：用双缝干涉测量光的波长',
            2881: '光的衍射',
            2928: '物质由大量分子组成',
            2929: '扩散现象',
            2930: '布朗运动',
            2931: '分子间的作用力',
            2932: '实验：用油膜法估测分子的大小',
            2935: '随机性和统计规律',
            2938: '状态参量与平衡态',
            2939: '热平衡与温度',
            2941: '焦耳实验',
            2942: '功与内能的改变',
            2956: '黑体与黑体辐射',
            2957: '光电效应',
            2958: '爱因斯坦光电效应方程',
            2959: '康普顿效应与光子的动量',
            2960: '电子',
            2962: '原子的核式结构模型',
            2964: '天然放射现象',
            2965: '射线的本质',
            2966: '原子核的组成',
            3089: '电路中的能量转化',
            3251: '电荷守恒定律',
            3252: '元电荷、比荷',
            3254: '静电力常量',
            3255: '库仑定律静力学问题',
            3256: '库仑定律动力学问题',
            3258: '电场',
            3259: '电场强度与电场力',
            3260: '点电荷的电场、匀强电场',
            3261: '电场线',
            3262: '电场强度的叠加',
            3264: '静电平衡',
            3265: '静电屏蔽',
            3269: '电势',
            3270: '电势差',
            3271: '等势面',
            3273: '电势差与电场强度的关系',
            3275: '电容器',
            3277: '电容',
            3279: '带电粒子在电场中的运动',
            3280: '示波管',
            3282: '电场线、等势面粒子运动轨迹的关系',
            3283: '利用等势面确定电场',
            3284: '带电粒子在电场和重力场组成的复合场中的运动',
            3286: '带电粒子在交变电场中的运动',
            3287: '电场中的图像问题',
            3290: '导体的电阻',
            3291: '影响导体电阻的因素',
            3292: '实验：描绘小灯泡伏安特性曲线',
            3293: '游标卡尺与螺旋测微器',
            3294: '测定金属的电阻率',
            3296: '串并联电路',
            3297: '电压表和电流表构造与改装',
            3298: '内接法与外接法',
            3299: '滑动变阻器限流接法与分压接法',
            3301: '欧姆表原理及使用',
            3302: '多用电表的原理及使用',
            3303: '探索黑箱内电阻',
            3304: '用多用表判断电路故障',
            3306: '实验：半偏法测电表内阻',
            3307: '实验：测电阻创新型实验',
            3308: '闭合电路能量分析',
            3309: '含电容器的闭合电路',
            3310: '实验：测定电池的电动势和内阻',
            3312: '能量与可持续发展',
            3313: '能量守恒定律',
            3315: '两种U-I图像',
            3316: '实验：测电源电动势和内阻创新型实验',
            3317: '几种常见的磁场',
            3318: '安培分子电流假说',
            3388: '安培力',
            3389: '左手定则',
            3390: '磁电式电流表',
            3392: '洛伦兹力的方向和大小',
            3393: '电视显像管的工作原理',
            3395: '带电粒子在匀强磁场中的运动',
            3397: '质谱仪和回旋加速器',
            3399: '带电粒子在组合场中的运动',
            3400: '带电粒子在复合场中的运动',
            3403: '楞次定律',
            3404: '右手定则',
            3407: '感应电动势的产生条件',
            3408: '法拉第电磁感应定律',
            3409: '导线切割磁感线时的感应电动势',
            3412: '电磁感应现象中的感生电场',
            3413: '涡流',
            3414: '电磁阻尼和电磁驱动',
            3416: '互感现象',
            3417: '自感现象',
            3418: '自感系数',
            3419: '磁场能量',
            3421: '电磁感应的综合问题',
            3425: '交变电流',
            3426: '交变电流的产生',
            3428: '交流电的四个值',
            3429: '正弦式交变电流的公式和图像',
            3430: '电感器对交变电流的阻碍作用',
            3431: '电容器对交变电流的阻碍作用',
            3434: '理想变压器',
            3435: '远距离输电',
            3436: '原副线圈电流、电压、功率的关系',
            3438: '交变电流与电磁感应的综合',
            3439: '理想变压器动态变化',
            3442: '电磁振荡的产生',
            3443: '电磁振荡中的过程分析',
            3444: '电磁波',
            3445: '麦克斯韦电磁场理论',
            3447: '无线电波的发射和接收',
            3449: '电磁波谱',
            3451: '传感器及种类',
            3456: '传感器的应用',
            3457: '利用传感器制作简单的自动控制装置',
            3458: '分子动理论',
            3459: '分子运动速率分布图像',
            3460: '气体压强的微观意义',
            3462: '分子动能',
            3463: '分子势能',
            3464: '物体的内能',
            3466: '温度计与温标',
            3467: '玻意耳定律',
            3469: '气体的等压变化',
            3473: '晶体和非晶体',
            3474: '晶体的微观结构',
            3475: '气体的等容变化',
            3476: '理想气体',
            3477: '理想气体状态方程',
            3478: '对气体实验定律的微观解释',
            3481: '气体实验定律综合应用',
            3482: '液体的微观结构',
            3483: '液体的表面张力',
            3484: '浸润和不浸润',
            3485: '毛细现象',
            3486: '液晶',
            3487: '饱和汽、饱和汽压',
            3488: '热与内能的改变',
            3489: '热力学第一定律',
            3493: '能量守恒定律（热学）',
            3495: '热力学第二定律',
            3496: '热力学定律与气体定律的综合',
            3497: '黑体辐射的实验规律',
            3498: '能量量子化',
            3499: '光的波粒二象性',
            3500: 'α粒子散射实验',
            3501: '光谱与氢原子光谱',
            3502: '氢原子光谱的实验规律',
            3503: '氢原子的能级公式和跃迁',
            3504: '玻尔理论对氢光谱的解释',
            3505: '玻尔理论的局限性',
            3507: '物质波',
            3508: '量子力学的应用',
            3510: '原子核的衰变',
            3511: '半衰期',
            3512: '核反应',
            3513: '放射性同位素及其应用',
            3514: '人工转变',
            3515: '质子和中子的发现',
            3516: '衰变反冲轨迹',
            3517: '辐射与安全',
            3520: '核力与四种基本相互作用',
            3523: '新粒子及分类',
            3524: '核裂变、裂变反应堆',
            3525: '核聚变',
            3526: '结合能',
            3527: '质量亏损',
            3528: '爱因斯坦质能方程',
            3533: '静力学的受力分析',
            3534: '静力学临界问题',
            3535: '多力平衡',
            3536: '整体法与隔离法',
            3537: '动态平衡',
            3538: '类平抛运动',
            3539: '斜抛运动',
            3540: '电场中的功能关系',
            3541: '激光的特点及其运用',
            3543: '实验：探究做功与物体动能变化的关系',
            3841: '一对滑动摩擦力做功',
            3861: '实验：探究小车速度随时间变化的规律',
            3864: '运动的合成与分解',
            3865: '行星运动的两种学说',
            10214: '光的颜色及色散定义',
            10219: '色散的几种情况',
            10782: '电磁波的传输、应用',
            12813: '物理学史',
            12815: '研究物理学方法',
            12816: '库伦定律的内容以及计算',
            12817: '电场与力学综合',
            12818: '带电粒子在有界磁场中的运动',
            12819: '带电粒子在磁场中运动的临界问题',
            12820: '带电粒子在磁场中运动的两个基本公式',
            12821: '带电粒子在磁场中的多解问题',
            12822: '速度选择器、磁流体发动机',
            12823: '电磁感应电路问题',
            12824: '电磁感应动力学问题',
            12825: '电磁感应能量以及动量问题',
            12826: '电磁感应图象问题',
            12827: '电磁感应单棒模型',
            12828: '电磁感应双棒模型',
            12829: '充气、抽气',
            12830: '灌气类问题',
            12831: '图象问题',
            12832: '水银柱类综合问题',
            12833: '活塞类综合问题'}

        self.kps_id_hfs2zxhx = {
         '* 不确定性关系': '无',
         '* 伯努利方程': '无',
         '* 同时的相对性': '经典时空观和相对论时空观_3216',
         '* 固体的微观结构': '晶体的微观结构_3474',
         '* 宇宙概观': '无',
         '* 广义相对论简介': '无',
         '* 感应电动机原理': '磁通量_1360',
         '* 晶体和非晶体': '晶体和非晶体_3473',
         '* 流体的压强和流速有关': '无',
         '* 液体的微观结构': '液体的微观结构_3482',
         '* 液体的表面张力现象和毛细现象': '一对多',
         '* 液晶': '液晶_3486',
         '* 用三角函数表示简谐运动': '简谐运动的表达式_3346',
         '* 相位': '一对多',
         '* 相对论速度叠加公式': '经典时空观和相对论时空观_3216',
         '* 质量和速度的关系': '经典时空观和相对论时空观_3216',
         '*相对湿度': '无',
         '*表面张力产生的原因': '浸润和不浸润_3484',
         '*饱和汽、未饱和汽和饱和汽压': '一对多',
         'lc振荡电路分析': '电磁振荡中的过程分析_3443',
         'v-t图像概念': 'v-t图象_3115',
         'v-t图像（匀变速直线运动）': 'x-t图象_3112',
         'x-t图像概念': 'x-t图象_3112',
         'x-t图像的概念': 'x-t图象_3112',
         'x-t图像（匀变速直线运动）': 'v-t图象_3115',
         'x射线、α射线、β射线、γ射线及其特性': '射线的本质_2965',
         'x射线管': '射线的本质_2965',
         'α粒子散射实验': 'α粒子散射实验_3500',
         '“一动一静”弹性正碰模型': '弹性碰撞_3333',
         '“二合一”模型': '弹性碰撞_3333',
         '“变质量气体”模型': '无',
         '“汽缸活塞类”模型': '活塞类综合问题_12833',
         '“玻璃管封液”模型': '水银柱类综合问题_12832',
         '万有引力定律及其应用': '万有引力定律_3205',
         '万有引力定律的发现': '万有引力定律_3205',
         '万有引力恒量的测定': '引力常量的测定_3206',
         '三相交变电流': '交变电流与电磁感应的综合_3438',
         '三相四线制及其线电压和相电压': '交变电流与电磁感应的综合_3438',
         '三相电流的线电压、相电压': '交变电流与电磁感应的综合_3438',
         '中间位置公式的应用': '匀变速直线运动规律和推论_3126',
         '串联电路和并联电路的特点': '串并联电路_3296',
         '临界角': '全反射_2867',
         '二力平衡及其应用': '无',
         '互成角度的两个匀速直线运动的合成': '运动的合成与分解_3864',
         '交变电流的周期和频率': '交流电的四个值_3428',
         '交变电流的图象和三角函数表达式': '正弦式交变电流的公式和图像_3429',
         '交变电流的峰值': '交流电的四个值_3428',
         '交变电流的平均值': '交流电的四个值_3428',
         '交变电流的有效值': '交流电的四个值_3428',
         '交变电流的相位': '交流电的四个值_3428',
         '交变电流的瞬时值': '交流电的四个值_3428',
         '交流发电机及其产生正弦式电流的原理': '交变电流的产生_3426',
         '交流电的产生': '一对多',
         '产生共振的条件及其应用': '共振_3360',
         '人类对物质结构的认识': '无',
         '人造卫星上进行微重力条件下的实验': '无',
         '伏安法测电阻': '无',
         '传动问题': '无',
         '传感器': '无',
         '传感器在生产、生活中的应用': '一对多',
         '传送带模型问题': '一对多',
         '估测压力锅内水的温度': '无',
         '估测油酸分子大小': '实验：用油膜法估测分子的大小_2932',
         '伽利略研究自由落体运动的实验和推理方法': '伽利略研究自由落体的实验_3123',
         '位移': '路程和位移_3107',
         '位移差公式的应用': '匀变速直线运动规律和推论_3126',
         '作用力和反作用力': '牛顿第三定律_3138',
         '信息传播、处理和存储技术的发展': '电磁波的传输、应用_10782',
         '做功的判断及功的正负': '一对相互作用力做功的特点_3246',
         '元电荷': '元电荷、比荷_3252',
         '光发生明显衍射的条件': '光的衍射_2881',
         '光子': '康普顿效应与光子的动量_2959',
         '光子的发射和吸收': '无',
         '光导纤维及其应用': '光导纤维及其运用_2869',
         '光敏电阻': '传感器及种类_3451',
         '光电效应实验': '光电效应_2957',
         '光电效应现象及其解释': '光电效应_2957',
         '光电效应的实验规律': '光电效应_2957',
         '光的偏振': '偏振、偏振现象及其运用_3384',
         '光的双缝干涉现象': '光的双缝干涉和薄膜干涉_2871',
         '光的反射定律': '无',
         '光的折射和全反射的综合应用': '无',
         '光的折射定律': '折射率_3381',
         '光的折射现象': '折射率_3381',
         '光的本性学说的发展简史': '无',
         '光的波粒二象性': '光的波粒二象性_3499',
         '光的电磁本性': '无',
         '光的薄膜干涉现象': '光的双缝干涉和薄膜干涉_2871',
         '光的衍射现象': '光的衍射_2881',
         '光谱和光谱分析': '光谱与氢原子光谱_3501',
         '光通过棱镜时的偏折和色散': '无',
         '全反射': '全反射_2867',
         '全反射的条件': '全反射_2867',
         '其他形式的电表改装': '无',
         '内燃机的工作原理': '能量守恒定律（热学）_3493',
         '内能的不同利用方式': '无',
         '冲量': '一对多',
         '决定向心力大小的因素': '向心力_3185',
         '冷暖两用空调机的工作原理': '无',
         '几种常见的磁场': '几种常见的磁场_3317',
         '分子力曲线': '无',
         '分子动理论的基本观点和实验依据': '分子动理论_3458',
         '分子动能': '分子动能_3462',
         '分子势能': '分子势能_3463',
         '分子势能曲线': '分子势能_3463',
         '分子电流假说': '安培分子电流假说_3318',
         '分子的大小': '物质由大量分子组成_2928',
         '分子的热运动': '布朗运动_2930',
         '分子运动速率的统计分布规律': '一对多',
         '分子间的相互作用力': '分子间的作用力_2931',
         '刚体的平衡条件': '无',
         '判断洛伦兹力的方向': '洛伦兹力的方向和大小_3392',
         '利用光电门研究匀变速直线运动': '实验：研究匀变速直线运动及改编实验_3129',
         '利用其他器材验证动量守恒定律': '实验：验证动量守恒定律_3331',
         '利用其他设备研究匀变速直线运动': '实验：研究匀变速直线运动及改编实验_3129',
         '利用动力学观点测定动摩擦因数': '无',
         '利用平抛运动规律验证动量守恒定律': '实验：验证动量守恒定律_3331',
         '利用平衡条件测定动摩擦因数': '无',
         '利用打点计时器研究匀变速直线运动': '实验：研究匀变速直线运动及改编实验_3129',
         '利用气垫导轨和光电门验证动量守恒定律': '实验：验证动量守恒定律_3331',
         '利用能量观点测定动摩擦因数': '无',
         '刹车时车轮被抱死的利与弊': '无',
         '刻度尺': '无',
         '力的合成': '力的合成_3140',
         '力的合成与分解的应用': '无',
         '力的合成的平行四边形定则': '平行四边形定则_3142',
         '力的效果分解法': '力的分解_3141',
         '力的概念及其矢量性': '力和力的性质_3130',
         '力的正交分解法': '力的分解_3141',
         '力的示意图': '力和力的性质_3130',
         '力矩和力偶': '无',
         '力矩的平衡条件': '无',
         '功率的概念': '功率_3229',
         '功的概念': '功_3228',
         '功能关系中图象问题的分析': '功能关系的应用_3249',
         '加速度': '加速度_3114',
         '加速度与力、质量的关系式': '实验：探究加速度与力、质量的关系_3152',
         '加速度与力的关系图象': '无',
         '加速度与质量的关系图象': '无',
         '动力学中的临界与极值问题': '动力学临界问题_3163',
         '动力学中的多物体多运动过程问题': '无',
         '动力学中的整体法与隔离法': '无',
         '动摩擦因数': '滑动摩擦力_3135',
         '动生电动势': '电磁感应现象中的感生电场_3412',
         '动能': '一对多',
         '动能和势能的相互转化': '动能与势能的相互转化_3242',
         '动能定理': '动能定理_3240',
         '动能定理与图象问题的结合': '动能与势能的相互转化_3242',
         '动能定理的应用': '动能定理的应用_3248',
         '动量': '一对多',
         '动量守恒定律的理解': '动量守恒定律_3329',
         '动量守恒定律的综合应用': '动量和能量综合问题_3338',
         '动量定理在“流体模型”中的应用': '动量定理的应用_3327',
         '动量定理的基本应用': '动量定理_3326',
         '动量定理的理解': '动量定理_3326',
         '匀变速直线运动的位移与时间的关系': '位移-时间的关系_3119',
         '匀变速直线运动的概念': '无',
         '匀变速直线运动的速度与位移的关系': '速度与位移的关系_3120',
         '匀变速直线运动的速度与时间的关系': '速度与时间的关系_3118',
         '匀变速直线运动规律的综合运用': '匀变速直线运动规律和推论_3126',
         '匀强电场': '点电荷的电场、匀强电场_3260',
         '匀强电场中电势差和电场强度的关系': '电势差与电场强度的关系_3273',
         '匀速圆周运动': '一对多',
         '匀速直线运动及其公式': '无',
         '匀速直线运动的图像': '无',
         '半偏法测电阻': '实验：半偏法测电表内阻_3306',
         '半圆内的平抛问题': '无',
         '半导体': '无',
         '单摆': '单摆_3352',
         '单摆周期公式': '单摆的周期_3354',
         '单杆切割磁感线': '导线切割磁感线时的感应电动势_3409',
         '单物体的机械能守恒问题': '机械能守恒的条件、机械能守恒定律_3243',
         '卫星的变轨与对接': '变轨与能量_3214',
         '卫星运行参量的分析': '卫星运行的规律(追击)_3212',
         '原子核的人工转变': '一对多',
         '原子核的组成': '原子核的组成_2966',
         '原子核的结合能': '结合能_3526',
         '原子核衰变': '一对多',
         '原子的核式结构': '原子的核式结构模型_2962',
         '参考系': '参考系与坐标系_3105',
         '双星和多星问题': '双星、多星问题_3224',
         '双杆切割磁感线': '导线切割磁感线时的感应电动势_3409',
         '双缝干涉的条纹间距与波长的关系': '光的干涉_2870',
         '反冲现象及其应用': '反冲运动_3336',
         '发现未知天体': '无',
         '受控聚变反应': '核聚变_3525',
         '变力做功': '一对多',
         '变压器的动态分析': '一对多',
         '变压器的构造和原理': '一对多',
         '可控热核反应': '核反应_3512',
         '右手定则': '右手定则_3404',
         '合力的大小与分力间夹角的关系': '力的合成_3140',
         '合运动与分运动的概念': '运动的合成与分解_3864',
         '同步卫星': '近地卫星、同步卫星_3213',
         '向心力': '一对多',
         '向心加速度': '向心加速度_3188',
         '含容电路分析': '含电容器的闭合电路_3309',
         '含弹簧类机械能守恒问题': '机械能守恒的条件、机械能守恒定律_3243',
         '喷气发动机的工作原理': '能量守恒定律（热学）_3493',
         '回旋加速器': '质谱仪和回旋加速器_3397',
         '国际单位制': '力学单位制_3155',
         '图像的选择': '运动图象_3125',
         '图像间的相互转化': '运动图象_3125',
         '图解法在动态平衡问题中的应用': '动态平衡_3537',
         '圆周运动中的临界问题': '圆周运动临界问题_3195',
         '圆周运动中脱轨与不脱轨问题': '圆周运动临界问题_3195',
         '地磁场': '地磁场_1458',
         '坐标系': '参考系与坐标系_3105',
         '声波': '多普勒效应_3377',
         '声波的干涉': '多普勒效应_3377',
         '声音的共呜': '多普勒效应_3377',
         '多个力的总功': '无',
         '多普勒效应': '多普勒效应_3377',
         '多物体组成的系统瞬时问题': '瞬时问题_3158',
         '多用电表的原理及其使用': '一对多',
         '天体中的相遇问题': '卫星运行的规律(追击)_3212',
         '天体质量或密度的计算': '一对多',
         '天体运动中的信息题': '无',
         '天然放射现象': '天然放射现象_2964',
         '安培力': '安培力_3388',
         '安培力作用下导体运动情况的判断': '电视显像管的工作原理_3393',
         '安培力作用下的平衡问题': '电视显像管的工作原理_3393',
         '安培力的计算': '安培力_3388',
         '安培定则': '安培定则_1460',
         '宏观物体和微观粒子的能量变化特点': '无',
         '实验中常用仪器及其正确操作方法': '无',
         '家庭电路和安全用电知识': '无',
         '家庭电路的连接': '无',
         '家用电器故障原因判断': '无',
         '家用电脑的组成': '电磁波的传输、应用_10782',
         '容抗': '电容器对交变电流的阻碍作用_3431',
         '对力和运动关系的研究': '伽利略理想实验_3148',
         '对着竖直墙壁平抛': '无',
         '导体的伏安特性曲线': '实验：描绘小灯泡伏安特性曲线_3292',
         '导线框切割磁感线': '导线切割磁感线时的感应电动势_3409',
         '射线管的构造及其工作原理': '示波管_3280',
         '小船渡河问题': '小船渡河问题_1328',
         '左手定则': '左手定则_3389',
         '布朗运动': '布朗运动_2930',
         '带电物体在洛伦兹力作用下的力学问题': '一对多',
         '带电物体在电场中的平衡问题': '无',
         '带电粒子在交变电场中的运动': '带电粒子在交变电场中的运动_3286',
         '带电粒子在匀强磁场中的运动规律': '一对多',
         '带电粒子在叠加场中无约束条件下的运动': '带电粒子在复合场中的运动_3400',
         '带电粒子在叠加场中有约束条件下的运动': '带电粒子在复合场中的运动_3400',
         '带电粒子在有界磁场中的圆周运动': '带电粒子在有界磁场中的运动_12818',
         '带电粒子在电场与磁场的组合场中的运动': '带电粒子在组合场中的运动_3399',
         '带电粒子在电场中的加（减）速和偏转': '带电粒子在电场中的运动_3279',
         '带电粒子在电场中的平衡问题': '无',
         '带电粒子在磁场与磁场的组合场中的运动': '带电粒子在组合场中的运动_3399',
         '带电粒子在磁场中的动态圆问题': '带电粒子在磁场中的多解问题_12821',
         '带电粒子在磁场中运动的临界和极值问题': '带电粒子在磁场中运动的临界问题_12819',
         '带电粒子在磁场运动的多解问题': '带电粒子在磁场中的多解问题_12821',
         '带电粒子在组合电场中的运动': '电场与力学综合_12817',
         '带电粒子在重力场和电场中的运动': '一对多',
         '常用裂变反应堆的类型': '核裂变、裂变反应堆_3524',
         '常见传感器的工作原理': '传感器及种类_3451',
         '常见家用电器技术参数的含义及其选用': '无',
         '常见家用电器的基本工作原理': '无',
         '常见电容器的构造': '无',
         '常见的传动装置': '无',
         '常见的承重结构及其特点': '无',
         '常见的电路元器件及其在电路中的作用': '无',
         '平动与转动': '无',
         '平均功率': '功率_3229',
         '平均速度': '平均速度和瞬时速度_3111',
         '平均速度公式的应用': '匀变速直线运动规律和推论_3126',
         '平抛物体与自由落体同时落地': '无',
         '平抛运动中的相遇问题': '平抛运动_3174',
         '平抛运动基本规律及推论的应用': '平抛运动_3174',
         '平抛运动的临界和极值问题': '平抛运动_3174',
         '平抛运动的概念': '无',
         '平行板电容器的电容': '电容_3277',
         '平行通电直导线间的作用': '无',
         '平衡中的临界与极值问题': '一对多',
         '平衡力的辨别': '作用力与平衡力_3137',
         '平衡条件的基本应用': '无',
         '平面镜成像': '无',
         '库仑力作用下的平衡问题': '一对多',
         '库仑定律': '一对多',
         '库仑定律与力学问题的综合应用': '无',
         '应用动能定理处理单个物体多过程的运动': '动能与势能的相互转化_3242',
         '应用动能定理处理物体系的运动': '动能与势能的相互转化_3242',
         '康普顿效应': '康普顿效应与光子的动量_2959',
         '开普勒定律': '一对多',
         '开普勒第三定律': '开普勒三大定律_3201',
         '弹力有无的判断': '弹力_3132',
         '弹性势能': '弹性势能_3234',
         '弹性势能的变化与弹力做功的关系': '弹性势能_3234',
         '弹性形变和范性形变': '弹力_3132',
         '弹性碰撞和非弹性碰撞': '一对多',
         '弹簧连接体': '连接体问题_3160',
         '录音机的结构和工作原理': '无',
         '影响感应电动势大小的因素': '感应电动势的产生条件_3407',
         '影响电阻大小的因素': '无',
         '影响稳度的因素': '无',
         '微波炉的结构和工作原理': '无',
         '恒力做功': '功_3228',
         '恒星的演化': '无',
         '惠更斯原理': '多普勒效应_3377',
         '惯性': '无',
         '感应电动势的产生条件': '感应电动势的产生条件_3407',
         '感应电流的产生条件': '产生感应电流的条件_1366',
         '感抗': '电感器对交变电流的阻碍作用_3430',
         '感生电动势': '电磁感应现象中的感生电场_3412',
         '打点计时器': '打点计时器使用_3117',
         '打点计时器系列实验中纸带的处理': '打点计时器使用_3117',
         '扩散': '扩散现象_2929',
         '折射率': '折射率_3381',
         '探究决定导线电阻的因素': '影响导体电阻的因素_3291',
         '探究功与速度变化的关系': '一对多',
         '探究加速度与物体质量、物体受力的关系': '实验：探究加速度与力、质量的关系_3152',
         '探究单摆的周期与摆长的关系': '无',
         '探究变压器电压与匝数的关系': '无',
         '探究小车速度随时间变化的规律': '实验：探究小车速度随时间变化的规律_3861',
         '探究弹力和弹簧伸长的关系': '实验：探究弹簧弹力与弹簧形变量的关系_3134',
         '探究影响摩擦力的大小的因素': '无',
         '探究物体弹性碰撞的一些特点': '无',
         '探究轻弹簧的弹性势能': '实验：探究弹簧弹性势能表达式_3235',
         '描绘小灯泡的伏安特性曲线': '实验：描绘小灯泡伏安特性曲线_3292',
         '摩擦力做功与能量转化': '功能关系的应用_3249',
         '摩擦力的判断': '一对多',
         '摩擦力的突变': '一对多',
         '摩擦力的计算': '滑动摩擦力_3135',
         '改变内能的两种方式': '一对多',
         '放射性同位素的应用': '放射性同位素及其应用_3513',
         '放射性污染和防护': '放射性同位素及其应用_3513',
         '整体法与隔离法在平衡问题中的应用': '整体法与隔离法_3536',
         '斜抛运动': '斜抛运动_3539',
         '斜面上的平抛问题': '无',
         '日光灯镇流器的作用和原理': '涡流_3413',
         '时间与时刻': '时刻和时间_3106',
         '时间间隔的相对性': '经典时空观和相对论时空观_3216',
         '星球表面的抛体问题': '无',
         '显微镜和望远镜': '无',
         '普适气体恒量': '无',
         '曲线运动的概念': '曲线运动的特点_3169',
         '有序、无序和熵': '无',
         '有效数字': '无',
         '机械': '无',
         '机械波': '一对多',
         '机械波的多解问题': '波长、频率和波速_3368',
         '机械能守恒的判断': '机械能守恒的条件、机械能守恒定律_3243',
         '机械运动': '无',
         '机车启动问题-恒定功率': '机车启动_3230',
         '机车启动问题-恒定加速度': '机车启动_3230',
         '杆端速度分解模型': '相关联问题_3170',
         '板块模型问题': '一对多',
         '核力的性质': '核力与四种基本相互作用_3520',
         '核反应堆': '核反应_3512',
         '核电站的工作模式': '无',
         '核能的计算': '一对多',
         '楞次定律': '楞次定律_3403',
         '概率波': '无',
         '模拟信号与数字信号的区别': '电磁波的传输、应用_10782',
         '横波和纵波': '横波和纵波_3364',
         '横波的图象': '一对多',
         '欧姆定律的应用': '无',
         '欧姆定律的概念': '无',
         '欧姆表的原理': '一对多',
         '正弦定理法在动态平衡问题中的应用': '动态平衡_3537',
         '比例法的应用': '匀变速直线运动规律和推论_3126',
         '比热容的概念': '无',
         '比热容解释简单的自然现象': '无',
         '气体分子运动的特点': '无',
         '气体压强的微观意义': '气体压强的微观意义_3460',
         '气体热现象的微观意义': '充气、抽气_12829',
         '气体状态变化的图象问题': '图象问题_12831',
         '气体的实验定律': '一对多',
         '气体的等压变化': '气体的等压变化_3469',
         '气体的等容变化': '气体的等容变化_3475',
         '气体的等温变化': '玻意耳定律_3467',
         '氢原子中的电子云': '无',
         '氢原子光谱': '光谱与氢原子光谱_3501',
         '氢原子的能级公式和跃迁': '氢原子的能级公式和跃迁_3503',
         '氢原子的能级结构': '氢原子的能级公式和跃迁_3503',
         '水平面内的圆周运动-摩擦力': '水平类圆周运动_3191',
         '水平面内的圆周运动-重力': '水平类圆周运动_3191',
         '永动机不能“永动”的原因': '无',
         '汽轮机的工作原理': '能量守恒定律（热学）_3493',
         '法拉第电磁感应定律': '法拉第电磁感应定律_3408',
         '波发生明显衍射的条件': '波的衍射_3372',
         '波的叠加': '波的叠加_3374',
         '波的干涉条件': '一对多',
         '波的干涉现象': '一对多',
         '波的形成和传播': '波的形成和传播_3363',
         '波的衍射现象': '波的衍射_3372',
         '波长、频率和波速的关系': '波长、频率和波速_3368',
         '洛伦兹力': '洛伦兹力的方向和大小_3392',
         '洛伦兹力的计算': '洛伦兹力的方向和大小_3392',
         '活塞式内燃机': '能量守恒定律（热学）_3493',
         '测光强': '无',
         '测定玻璃的折射率': '实验：测定玻璃的折射率_3382',
         '测定电源的电动势和内阻': '一对多',
         '测定重力加速度': '无',
         '测定金属的电阻率': '测定金属的电阻率_3294',
         '测量人在某种运动中的功率': '无',
         '测量加速度、力、质量': '实验：探究加速度与力、质量的关系_3152',
         '浸润和不浸润': '浸润和不浸润_3484',
         '涡流现象及其应用': '涡流_3413',
         '温度、气体压强和内能': '无',
         '温度和温标': '温度计与温标_3466',
         '游标卡尺': '游标卡尺与螺旋测微器_3293',
         '滑动变阻器的两种接法': '滑动变阻器限流接法与分压接法_3299',
         '滑动摩擦力': '滑动摩擦力_3135',
         '激光的特性和应用': '激光的特点及其运用_3541',
         '点电荷': '无',
         '点电荷的场强': '点电荷的电场、匀强电场_3260',
         '点电荷的电场线': '电场线_3261',
         '热力学第一定律': '热力学第一定律_3489',
         '热力学第二定律': '热力学第二定律_3495',
         '热力学第二定律的应用': '热力学定律与气体定律的综合_3496',
         '热平衡和热平衡规律': '一对多',
         '热敏电阻和金属热电阻': '传感器及种类_3451',
         '热机对环境的影响及减小影响的方法': '无',
         '热机的工作原理': '能量守恒定律（热学）_3493',
         '热机的效率': '能量守恒定律（热学）_3493',
         '热机的能量转化与守恒问题': '能量守恒定律（热学）_3493',
         '热量': '一对多',
         '焦耳定律': '焦耳定律_2860',
         '焦耳定律的应用': '焦耳定律_2860',
         '照相机': '无',
         '爱因斯坦光电效应方程': '爱因斯坦光电效应方程_2958',
         '爱因斯坦相对性原理和光速不变原理': '经典时空观和相对论时空观_3216',
         '爱因斯坦质能方程': '爱因斯坦质能方程_3528',
         '牛顿第一定律的概念': '牛顿第一定律_3149',
         '牛顿第三定律的概念': '牛顿第三定律_3138',
         '牛顿第二定律的概念': '牛顿第二定律_3151',
         '牛顿运动定律的应用-超重和失重': '超重与失重_3164',
         '牛顿运动定律的应用—从受力确定运动': '两类动力学_3166',
         '牛顿运动定律的应用—从运动确定受力': '两类动力学_3166',
         '物体做曲线运动的条件': '曲线运动的条件_1323',
         '物体平衡的稳定性': '无',
         '物体的内能': '物体的内能_3464',
         '物体的弹性和弹力': '弹力_3132',
         '物态变化中的能量交换': '无',
         '物物叠放连接体': '连接体问题_3160',
         '物物挤压连接体': '连接体问题_3160',
         '物理学史': '物理学史_12813',
         '物理学方法': '研究物理学方法_12815',
         '物理模型的特点及作用': '无',
         '物理量单位推导': '量纲法_3156',
         '物质波': '一对多',
         '特殊带电体电场强度的计算': '无',
         '狭义相对论': '一对多',
         '玻尔理论': '玻尔理论对氢光谱的解释_3504',
         '玻尔理论的局限性': '一对多',
         '理想气体': '理想气体_3476',
         '理想气体的状态方程': '理想气体状态方程_3477',
         '生活中的静电现象': '无',
         '用传感器或其他器材测速验证机械能守恒定律': '实验：验证机械能守恒定律_3245',
         '用光电门测速法验证机械能守恒定律': '实验：验证机械能守恒定律_3245',
         '用分子动理论和统计观点解释气体压强': '无',
         '用单摆测定重力加速度': '实验：探究单摆的运动、用单摆测定重力加速度_3355',
         '用双缝干涉实验测光的波长': '实验：用双缝干涉测量光的波长_2874',
         '用双缝干涉实验测定光的波长': '实验：用双缝干涉测量光的波长_2874',
         '用多用电表探索黑箱内的电学元件': '探索黑箱内电阻_3303',
         '用多用电表测电阻': '多用电表的原理及使用_3302',
         '用打点计时器测速度': '一对多',
         '用描迹法画出电场中平面上的等势线': '无',
         '用油膜法估测分子的大小': '实验：用油膜法估测分子的大小_2932',
         '用牛顿运动定律分析斜面体模型': '无',
         '用电解法测定元电荷': '无',
         '用纸带测速法（落体法）验证机械能守恒定律': '实验：验证机械能守恒定律_3245',
         '电功': '电功和电功率_2859',
         '电功率': '电功和电功率_2859',
         '电势': '电势_3269',
         '电势与电势能的关系': '无',
         '电势差': '电势差_3270',
         '电势差与电场强度的关系': '电势差与电场强度的关系_3273',
         '电势能': '电势能_2854',
         '电场': '电场_3258',
         '电场中轨迹类问题的分析': '电场线、等势面粒子运动轨迹的关系_3282',
         '电场力做功与电势能变化的关系': '静电力做功_2853',
         '电场力做功的计算': '静电力做功_2853',
         '电场强度': '电场强度与电场力_3259',
         '电场的叠加': '电场强度的叠加_3262',
         '电场线': '电场线_3261',
         '电子束的磁偏转原理及其应用': '一对多',
         '电子的发现': '电子_2960',
         '电子的比荷': '元电荷、比荷_3252',
         '电容': '电容_3277',
         '电容器': '电容器_3275',
         '电容器和电感器对交变电流的导通和阻碍作用': '一对多',
         '电容器的动态分析': '无',
         '电桥法测电阻': '实验：测电阻创新型实验_3307',
         '电流概念': '无',
         '电流的微观表达式': '电流表达式_2856',
         '电流的磁场对磁针的作用': '电流的磁效应_1456',
         '电流表改装电压表': '电压表和电流表构造与改装_3297',
         '电流表改装电流表': '电压表和电流表构造与改装_3297',
         '电流表的内接法和外接法': '内接法与外接法_3298',
         '电源的功率和效率': '一对多',
         '电源的电动势和内阻': '一对多',
         '电磁场': '电磁场_1375',
         '电磁感应中的动力学问题': '电磁感应动力学问题_12824',
         '电磁感应中的图象问题': '电磁感应图象问题_12826',
         '电磁感应中的电路类问题': '电磁感应电路问题_12823',
         '电磁感应中的能量问题': '电磁感应能量以及动量问题_12825',
         '电磁感应在生活和生产中的应用': '电磁感应现象的应用_1367',
         '电磁感应现象的发现过程': '无',
         '电磁振荡': '电磁振荡的产生_3442',
         '电磁波在日常生活和生产中的广泛应用': '电磁波的传输、应用_10782',
         '电磁波的产生': '一对多',
         '电磁波的发射、传播和接收': '无线电波的发射和接收_3447',
         '电磁波的周期、频率和波速': '电磁波_1376',
         '电磁波的应用': '电磁波的传输、应用_10782',
         '电磁波谱': '电磁波谱_1378',
         '电磁流量计': '磁电式电流表_3390',
         '电磁灶的结构和原理': '涡流_3413',
         '电磁阻尼和电磁驱动': '电磁阻尼和电磁驱动_3414',
         '电荷守恒定律': '电荷守恒定律_3251',
         '电视、广播和电视机的工作模式': '电磁波的传输、应用_10782',
         '电视、广播技术的新进展': '电磁波的传输、应用_10782',
         '电视机的主要结构': '电磁波的传输、应用_10782',
         '电路故障分析': '无',
         '电阻器、电容器和电感器的识别': '无',
         '电阻定律': '影响导体电阻的因素_3291',
         '电阻率与温度的关系': '影响导体电阻的因素_3291',
         '电阻的定义': '导体的电阻_3290',
         '直导线在磁场中运动时感应电流的方向': '产生感应电流的条件_1366',
         '相互作用力与平衡力的比较': '作用力与平衡力_3137',
         '相似三角形法在动态平衡问题中的应用': '动态平衡_3537',
         '瞬时功率': '功率_3229',
         '瞬时速度': '平均速度和瞬时速度_3111',
         '矢量和标量': '矢量和标量_3108',
         '研制水“火箭”': '无',
         '研究匀变速直线运动': '匀变速直线运动规律和推论_3126',
         '研究平抛物体的运动': '研究平抛运动_3172',
         '研究平行板电容器': '无',
         '研究弹簧振子的周期和小球质量的关系': '无',
         '研究材料的保温性能': '无',
         '研究玩具电机的能量转化': '无',
         '研究电磁感应现象': '无',
         '研究自由落体运动的规律': '伽利略研究自由落体的实验_3123',
         '研究闭合电路的欧姆定律': '无',
         '破坏臭氧层的原因与后果': '无',
         '磁场对电流的作用': '无',
         '磁场的叠加': '无',
         '磁感应强度': '磁感应强度_1358',
         '磁感线及用磁感线描述磁场': '磁感线_1459',
         '磁极间的相互作用': '磁现象_1455',
         '磁流体发电机': '速度选择器、磁流体发动机_12822',
         '磁现象和磁场': '一对多',
         '磁电式电表原理': '磁电式电流表_3390',
         '磁通量': '磁通量_1360',
         '示波器': '无',
         '示波管及其使用': '示波管_3280',
         '离心现象': '离心、近心现象_3193',
         '移动电话的工作原理': '电磁波的传输、应用_10782',
         '移动通信的工作原理': '电磁波的传输、应用_10782',
         '空气对落体运动的影响': '无',
         '竖直上抛运动': '竖直上抛和类竖直上抛运动_3127',
         '竖直面内的圆周运动-弹力': '竖直类圆周运动_3192',
         '竖直面内的圆周运动-轻杆模型': '绳杆模型_3196',
         '竖直面内的圆周运动-轻绳模型': '绳杆模型_3196',
         '第一宇宙速度': '三种宇宙速度_3211',
         '第二宇宙速度和第三宇宙速度': '三种宇宙速度_3211',
         '等势面': '一对多',
         '等效法测电阻': '实验：测电阻创新型实验_3307',
         '等时圆问题': '无',
         '等量电荷的电场线': '电场线_3261',
         '简单的逻辑电路': '无',
         '简谐运动': '弹簧振子_3342',
         '简谐运动的回复力和能量': '一对多',
         '简谐运动的振动图象': '振动图象_3343',
         '简谐运动的振幅、周期和频率': '振幅、周期、频率、相位_3344',
         '类单摆问题': '单摆的周期_3354',
         '类平抛运动': '类平抛运动_3538',
         '粒子和宇宙': '新粒子及分类_3523',
         '粒子散射实验': 'α粒子散射实验_3500',
         '粒子物理学的基础知识': '无',
         '系统动量守恒的判断': '动量守恒定律_3329',
         '系统机械能守恒定律的应用': '机械能守恒定律的应用_3244',
         '紫外线的荧光效应及其应用': '无',
         '红外线的热效应和红外线遥控': '无',
         '线速度、角速度和周期、转速': '描述圆周运动的物理量_3181',
         '经典力学的局限性': '牛顿力学的局限性_3217',
         '经典时空观与相对论时空观的主要区别': '经典时空观和相对论时空观_3216',
         '绳端速度分解模型': '相关联问题_3170',
         '网络技术对经济、社会的影响': '电磁波的传输、应用_10782',
         '胡克定律': '胡克定律_3133',
         '能源的分类': '无',
         '能源的利用与环境保护': '无',
         '能源的开发和利用': '无',
         '能量守恒定律的应用': '无',
         '能量的分类': '无',
         '能量转化和转移的方向性': '无',
         '自感现象和自感系数': '一对多',
         '自感现象的应用': '一对多',
         '自来水电阻率的测定': '无',
         '自由振动和受迫振动': '受迫振动_3359',
         '自由落体运动的概念': '自由落体运动_3122',
         '自由落体运动的计算': '自由落体运动_3122',
         '致冷原理': '无',
         '菜刀上的力学知识': '无',
         '落点在曲面上的平抛运动': '无',
         '薄膜干涉的应用': '光的双缝干涉和薄膜干涉_2871',
         '螺旋测微器': '游标卡尺与螺旋测微器_3293',
         '衰变周期、衰变速度': '半衰期_3511',
         '裂变反应和聚变反应': '一对多',
         '解析法在动态平衡问题中的应用': '动态平衡_3537',
         '解直角三角形在三力平衡问题中的应用': '一对多',
         '误差': '无',
         '质点的认识': '质点_3104',
         '质谱仪': '质谱仪和回旋加速器_3397',
         '起电的三种方式': '电荷、三种起电方式_2851',
         '超声波及其应用': '多普勒效应_3377',
         '超重和失重': '超重与失重_3164',
         '路程': '路程和位移_3107',
         '路端电压与负载的关系': '无',
         '轻弹簧瞬时问题': '瞬时问题_3158',
         '轻杆连接体': '连接体问题_3160',
         '轻核与重核内中子数、质子数具有不同比例的原因': '无',
         '轻核的聚变': '一对多',
         '轻绳、轻杆瞬时问题': '瞬时问题_3158',
         '轻绳连接体': '连接体问题_3160',
         '运动的合成与分解': '运动的合成与分解_3864',
         '近地卫星': '一对多',
         '远距离输电': '远距离输电_3435',
         '连接体的机械能守恒问题': '机械能守恒的条件、机械能守恒定律_3243',
         '逆向思维法的应用': '无',
         '透镜成像规律': '无',
         '通电导体在匀强磁场中的加速': '电视显像管的工作原理_3393',
         '通电直导线和通电线圈周围磁场的方向': '无',
         '速度': '速度与速率_3110',
         '速度、速度变化量和加速度的关系': '加速度_3114',
         '速度选择器': '速度选择器、磁流体发动机_12822',
         '速率': '速度与速率_3110',
         '重力': '重力_3131',
         '重力加速度': '无',
         '重力势能': '一对多',
         '重力势能的变化与重力做功的关系': '重力做功与重力势能的变化关系_3233',
         '重心': '重力_3131',
         '重核的裂变': '核裂变、裂变反应堆_3524',
         '量子化现象': '能量量子化_3498',
         '链式反应及其发生条件': '核裂变、裂变反应堆_3524',
         '长度的测量': '游标卡尺与螺旋测微器_3293',
         '长度的相对性': '经典时空观和相对论时空观_3216',
         '长波、中波、短波、微波的不同传播特点': '电磁波的传输、应用_10782',
         '闭合电路中的能量转化': '一对多',
         '闭合电路的动态分析': '一对多',
         '闭合电路的欧姆定律': '闭合电路的欧姆定律_2862',
         '阻尼运动': '能量、阻尼振动_3357',
         '阿伏加德罗常数': '物质由大量分子组成_2928',
         '随地、绕地问题': '无',
         '集成电路与微电子技术': '电磁波的传输、应用_10782',
         '集成电路的作用': '无',
         '霍尔效应及其应用': '质谱仪和回旋加速器_3397',
         '静摩擦力和最大静摩擦力': '静摩擦力_3136',
         '静摩擦在日常生活中的应用': '静摩擦力_3136',
         '静电场中的e-x图象问题': '电场中的图像问题_3287',
         '静电场中的ep-x图象问题': '电场中的图像问题_3287',
         '静电场中的v-t图像问题': '电场中的图像问题_3287',
         '静电场中的φ-x图象问题': '电场中的图像问题_3287',
         '静电屏蔽': '静电屏蔽_3265',
         '静电平衡': '静电平衡_3264',
         '静电感应': '无',
         '非匀变速直线运动': '无',
         '非常规图像': '一对多',
         '颜色及光的色散': '一对多',
         '验证力的平行四边形定则': '实验：验证力的平行四边形定则_3143',
         '验证动能定理': '实验：探究做功与物体动能变化的关系_3543',
         '验证牛顿第二运动定律': '实验：牛顿第二定律创新型实验_3153',
         '高清晰度电视与普通电视的主要区别': '电磁波的传输、应用_10782',
         '黑体与黑体辐射': '一对多',
        }

if __name__ == '__main__':
    import os
    import my_config
    import configparser
    from pprint import pprint
    # cfgpath = os.path.join(my_config.config_realpath, "label_id_phy.ini")  # 配置文件的路径
    # conf = configparser.ConfigParser()  # 创建管理对象
    # conf.read(cfgpath, encoding="utf-8")  # 读ini文件  python3
    # pprint(dict(conf.items('kps_id_hfs2zxhx')))
    # print(len(id2kps_phy))
    # print(len(sps_first_id))
